#include <stdbool.h>
#include "io430.h"
#include "display02.h"

enum Operation {add, subtract, multiply, divide};
typedef enum Operation Operation;

int main(void)
{
  initialize();

  while(true)
  {
    writeString("Zahl 1:");
    int inc = 0;
    while(inc == 0)
    {
      inc = getIncrement();
    }
    int z1 = 10;
    while(getMillisecondsSinceLastChange() < 1000)
    {   
      z1 += getIncrement();
      if(z1 < 0)
      {
        z1 = 0;
      }
      else if(z1 > 100)
      {
        z1 = 100;
      }
      writeNumber(z1);
    }    

    writeString("Rechne:");
    inc = 0;
    while(inc == 0)
    {      
      inc = getIncrement();
    }
    Operation op = add;
    while(getMillisecondsSinceLastChange() < 1000)
    {
      inc = getIncrement();
      if(-inc > op) // Zu weit nach unten gescrollt?
      {
        op = add;
      }
      else
      {
        op += inc;
        if(op > divide)
        {
          op = divide;
        }             
      }
      switch(op)
      {
      case add:
        writeString("plus");
        break;
      case subtract:
        writeString("minus");
        break;
      case multiply:
        writeString("mal");
        break;
      case divide:
        writeString("geteilt");
        break;        
      }
    }  

    // Codeverdopplung! Unschn!
    writeString("Zahl 2:");
    inc = 0;
    while(inc == 0)
    {    
      inc = getIncrement();
    }
    int z2 = 10;
    while(getMillisecondsSinceLastChange() < 1000)
    { 
      z2 += getIncrement();
      if(z2 < 0)
      {
        z2 = 0;
      }
      else if(z2 > 100)
      {
        z2 = 100;
      }
      writeNumber(z2);
    }    
    
    int result = -999;
    switch(op)
    {
    case add:
      result = z1 + z2;
      break;
    case subtract:
      result = z1 - z2;
      break;
    case multiply:
      result = z1 * z2;
      break;
    case divide:
      result = z1 / z2;
      break;        
    }
    writeString("Ergibt:");
    waitMilliseconds(500);
    if(result >= 0)
    {
      writeNumber(result);      
    }
    else
    {
      writeString("negativ");
    }
    waitMilliseconds(2000);
  }
  
  // berflssig wegen Endlosschleife:
  // return 0;
}